Index: ta/branches/presentation/worlds/sp_level_ambush_at_jupiter.oxw
===================================================================
--- /data/branches/presentation/worlds/sp_level_ambush_at_jupiter.oxw	(revision 4112)
+++ 	(revision )
@@ -1,326 +1,0 @@
-<WorldDataFile>
-  <name>Ambush_at_Uranus</name>
-  <menu-item-image>pictures/menu/Scienceproject_512x512.jpg</menu-item-image>
-  <screenshoot>pictures/menu/Scienceproject_512x512.jpg</screenshoot>
-
-  <LoadScreen>
-    <BackgroundImage>pictures/load_screens/default.jpg</BackgroundImage>
-    <ElementCount>16</ElementCount>
-    <BackgroundPS>0,0,1.0,1</BackgroundPS>
-    <BarPS>.65,.87,.3,.05</BarPS>
-    <BarImage>pictures/load_screens/default_bar.png</BarImage>
-  </LoadScreen>
-
-
-  <ScriptManager>
-
-   <Scripts>
-
-    <Script>
-     <file>guard.lua</file>
-    </Script>
-
-    <Script>
-     <file>secondguard.lua</file>
-    </Script>
-
-    <Script>
-     <file>prisoner.lua</file>
-    </Script>
-
-    <Script>
-     <file>secondprisoner.lua</file>
-    </Script>
-
-    <Script>
-     <file>falldown.lua</file>
-    </Script>
-
-    <Script>
-     <file>floorguy.lua</file>
-    </Script>
-
-    <Script>
-     <file>hangar.lua</file>
-    </Script>
-
-    <Script>
-     <file>spaceship_flight.lua</file>
-    </Script>
-
-   </Scripts>
-
-   <ScriptTriggers>
-
-    <ScriptTrigger>
-     <name>falldowntrigger</name>
-     <file>falldown.lua</file>
-     <function>tick</function>
-     <abs-coor>763, 0, 34</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-     <debugdraw>true</debugdraw>
-    </ScriptTrigger>
-
-    <ScriptTrigger>
-     <name>guardtrigger</name>
-     <file>guard.lua</file>
-     <function>tick</function>
-     <abs-coor>-84, 19, 77</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-    </ScriptTrigger>
-
-    <ScriptTrigger>
-     <name>secondguardtrigger</name>
-     <file>secondguard.lua</file>
-     <function>tick</function>
-     <abs-coor>-84, 19, 77</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-    </ScriptTrigger>
-
-    <ScriptTrigger>
-     <name>prisonertrigger</name>
-     <file>prisoner.lua</file>
-     <function>tick</function>
-     <abs-coor>-84, 19, 77</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-    </ScriptTrigger>
-
-   <ScriptTrigger>
-     <name>secondprisonertrigger</name>
-     <file>secondprisoner.lua</file>
-     <function>tick</function>
-     <abs-coor>-84, 19, 77</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-    </ScriptTrigger>
-
-    <ScriptTrigger>
-     <name>hangartrigger</name>
-     <file>hangar.lua</file>
-     <function>tick</function>
-     <abs-coor>678.946838, -11.959779, -920.512634</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-     <debugdraw>true</debugdraw>
-    </ScriptTrigger>
-
-
-    <ScriptTrigger>
-     <name>floorguytrigger</name>
-     <file>floorguy.lua</file>
-     <function>tick</function>
-     <abs-coor>576.753357, 19, 508.746613</abs-coor>
-     <radius>100</radius>
-     <worldentity>Player</worldentity>
-    </ScriptTrigger>
-
-    <ScriptTrigger>
-     <name>spaceship_flight_trigger</name>
-     <file>spaceship_flight.lua</file>
-     <function>tick</function>
-     <abs-coor>2500, 0, -1695</abs-coor>
-     <radius>150</radius>
-     <worldentity>SPACE_CRAFT</worldentity>
-     <debugdraw>true</debugdraw>
-    </ScriptTrigger>
-
-   </ScriptTriggers>
-
-  </ScriptManager>
-
-  <clip-region>1.0, 60000</clip-region>
-  <WorldEntities>
-
-    <SkyBox>
-     <name>Sky</name>
-     <Materialset>pictures/sky/simple_space</Materialset>
-     <Size>50000</Size>
-    </SkyBox>
-
-    <BspEntity>
-      <Name>worlds/bsp/single_player_proto_world_01.bsp</Name>
-    </BspEntity>
-
-    <GenericNPC>
-       <name>guard</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_viper.pcx</md2texture>
-       <abs-coor>275.33, 34, 241.26</abs-coor>
-       <abs-dir>-3.1, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-    <GenericNPC>
-       <name>secondguard</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_freakmagnet.pcx</md2texture>
-       <abs-coor>440, 90, 180</abs-coor>
-       <abs-dir>-3.1, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-
-    <GenericNPC>
-       <name>prisoner</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_albat.pcx</md2texture>
-       <abs-coor>-69,36, 74</abs-coor>
-       <abs-dir>-1.55, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-   <GenericNPC>
-       <name>Secondprisoner</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_fiend.pcx</md2texture>
-       <abs-coor>20, 34,110</abs-coor>
-       <abs-dir>-1.55, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-    <GenericNPC>
-       <name>statist</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_sarge.pcx</md2texture>
-       <abs-coor>-58, 34, 496</abs-coor>
-       <abs-dir>0, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-    <GenericNPC>
-       <name>statist2</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_sarge.pcx</md2texture>
-       <abs-coor>-65, 34, 528</abs-coor>
-       <abs-dir>0, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-    <GenericNPC>
-       <name>floorguy</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_sarge.pcx</md2texture>
-       <abs-coor>800.634338, -10, -340.454163</abs-coor>
-       <abs-dir>0, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-   <GenericNPC>
-       <name>mechanic</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_navy2.pcx</md2texture>
-       <abs-coor>991.192261, 5, -1878.394287</abs-coor>
-       <abs-dir>0, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-
-    <GenericNPC>
-       <name>mechanic2</name>
-       <model>models/creatures/male.md2, 10</model>
-       <md2texture>male_navy2.pcx</md2texture>
-       <abs-coor>1564.473999, 5, -1923.821533</abs-coor>
-       <abs-dir>0, 0, 1, 0</abs-dir>
-    </GenericNPC>
-
-   <TestEntity>
-       <name>fallingguy</name>
-       <model>models/creatures/doom_guy.md2, 10</model>
-       <md2texture>doom_guy.png</md2texture>
-       <abs-coor>620.5, 500, -750</abs-coor>
-       <abs-dir>-1.55, 0, 0, 1</abs-dir>
-    </TestEntity>
-
-    <Door>
-       <name>laboratory door</name>
-       <scale>32.0</scale>
-       <action-radius>40.0</action-radius>
-       <abs-coor>173, 47, 280</abs-coor>
-    </Door>
-
-
-    <RepairStation>
-       <name>repair station 01</name>
-       <scale>80.0</scale>
-       <abs-coor>814.349670, -21.959781, -1695.255981</abs-coor>
-    </RepairStation>
-
-
-    <FPSPlayer>
-      <name>Player</name>
-      <abs-coor>-148,20,87</abs-coor>
-      <model>models/creatures/droidika.md2, 10</model>
-      <md2texture>droidika.png</md2texture>
-    </FPSPlayer>
-
-
-    <Spacecraft2D>
-      <name>SPACE_CRAFT</name>
-      <abs-coor>1600, 0.004610, -1700.0</abs-coor>
-      <enter-radius>100000</enter-radius>
-      <travel-speed>20</travel-speed>
-      <travel-height>5</travel-height>
-      <travel-distance>40, 80</travel-distance>
-    </Spacecraft2D>
-
-    <SpaceShip>
-      <name>spaceship</name>
-      <model>models/ships/fighter.obj,20</model>
-      <abs-coor>624.164124, 0.004610, -1721.440796</abs-coor>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>spaceship1</name>
-      <model>models/ships/reap_#.obj,20</model>
-      <abs-coor>1160.289307, -10.959778, -1874.250732</abs-coor>
-      <abs-dir> -1.5,0,1,0 </abs-dir>
-    </SpaceShip>
-
-    <SpaceShip>
-      <name>spaceship2</name>
-      <model>models/ships/mantawing.obj,20</model>
-      <abs-coor>1373.289307, -10.959778, -1874.250732</abs-coor>
-      <abs-dir> -1.5,0,1,0 </abs-dir>
-    </SpaceShip>
-
-
-    <SpaceShip>
-      <name>spaceship3</name>
-      <model>models/ships/powerdrifter.obj,15</model>
-      <abs-coor>811.904358, -11.959779, -1698.305786</abs-coor>
-    </SpaceShip>
-
-
-
-    <!-- HERE IS THE ARCADE SHOOTER -->
-    <!-- NPC's -->
-    <NPC2> <abs-coor>2500, 0.004610, -1700.0</abs-coor> </NPC2>
-
-
-
-    <!-- BELOW THIS LINE (delete this line later)-->
-
-
-    <!--
-    <TurbineHover>
-      <name>Player</name>
-    </TurbineHover>
-    -->
-
-<!--
-    <TestEntity>
-      <model>models/creatures/gork</model>
-    </TestEntity>
--->
-  </WorldEntities>
-
-
-    <LightManager>
-    <Lights>
-      <Light>
-       <diffuse-color>1,1,1</diffuse-color>
-       <abs-coor>100,100,50</abs-coor>
-      </Light>
-    </Lights>
-    <ambient-color>1,1,1</ambient-color>
-  </LightManager>
-
-
-</WorldDataFile>
-
Index: /data/branches/presentation/worlds/sp_level_ambush_at_uranus.oxw
===================================================================
--- /data/branches/presentation/worlds/sp_level_ambush_at_uranus.oxw	(revision 4113)
+++ /data/branches/presentation/worlds/sp_level_ambush_at_uranus.oxw	(revision 4113)
@@ -0,0 +1,326 @@
+<WorldDataFile>
+  <name>Ambush_at_Uranus</name>
+  <menu-item-image>pictures/menu/Scienceproject_512x512.jpg</menu-item-image>
+  <screenshoot>pictures/menu/Scienceproject_512x512.jpg</screenshoot>
+
+  <LoadScreen>
+    <BackgroundImage>pictures/load_screens/default.jpg</BackgroundImage>
+    <ElementCount>16</ElementCount>
+    <BackgroundPS>0,0,1.0,1</BackgroundPS>
+    <BarPS>.65,.87,.3,.05</BarPS>
+    <BarImage>pictures/load_screens/default_bar.png</BarImage>
+  </LoadScreen>
+
+
+  <ScriptManager>
+
+   <Scripts>
+
+    <Script>
+     <file>guard.lua</file>
+    </Script>
+
+    <Script>
+     <file>secondguard.lua</file>
+    </Script>
+
+    <Script>
+     <file>prisoner.lua</file>
+    </Script>
+
+    <Script>
+     <file>secondprisoner.lua</file>
+    </Script>
+
+    <Script>
+     <file>falldown.lua</file>
+    </Script>
+
+    <Script>
+     <file>floorguy.lua</file>
+    </Script>
+
+    <Script>
+     <file>hangar.lua</file>
+    </Script>
+
+    <Script>
+     <file>spaceship_flight.lua</file>
+    </Script>
+
+   </Scripts>
+
+   <ScriptTriggers>
+
+    <ScriptTrigger>
+     <name>falldowntrigger</name>
+     <file>falldown.lua</file>
+     <function>tick</function>
+     <abs-coor>763, 0, 34</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+     <debugdraw>true</debugdraw>
+    </ScriptTrigger>
+
+    <ScriptTrigger>
+     <name>guardtrigger</name>
+     <file>guard.lua</file>
+     <function>tick</function>
+     <abs-coor>-84, 19, 77</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+    </ScriptTrigger>
+
+    <ScriptTrigger>
+     <name>secondguardtrigger</name>
+     <file>secondguard.lua</file>
+     <function>tick</function>
+     <abs-coor>-84, 19, 77</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+    </ScriptTrigger>
+
+    <ScriptTrigger>
+     <name>prisonertrigger</name>
+     <file>prisoner.lua</file>
+     <function>tick</function>
+     <abs-coor>-84, 19, 77</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+    </ScriptTrigger>
+
+   <ScriptTrigger>
+     <name>secondprisonertrigger</name>
+     <file>secondprisoner.lua</file>
+     <function>tick</function>
+     <abs-coor>-84, 19, 77</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+    </ScriptTrigger>
+
+    <ScriptTrigger>
+     <name>hangartrigger</name>
+     <file>hangar.lua</file>
+     <function>tick</function>
+     <abs-coor>678.946838, -11.959779, -920.512634</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+     <debugdraw>true</debugdraw>
+    </ScriptTrigger>
+
+
+    <ScriptTrigger>
+     <name>floorguytrigger</name>
+     <file>floorguy.lua</file>
+     <function>tick</function>
+     <abs-coor>576.753357, 19, 508.746613</abs-coor>
+     <radius>100</radius>
+     <worldentity>Player</worldentity>
+    </ScriptTrigger>
+
+    <ScriptTrigger>
+     <name>spaceship_flight_trigger</name>
+     <file>spaceship_flight.lua</file>
+     <function>tick</function>
+     <abs-coor>2500, 0, -1695</abs-coor>
+     <radius>150</radius>
+     <worldentity>SPACE_CRAFT</worldentity>
+     <debugdraw>true</debugdraw>
+    </ScriptTrigger>
+
+   </ScriptTriggers>
+
+  </ScriptManager>
+
+  <clip-region>1.0, 60000</clip-region>
+  <WorldEntities>
+
+    <SkyBox>
+     <name>Sky</name>
+     <Materialset>pictures/sky/simple_space</Materialset>
+     <Size>50000</Size>
+    </SkyBox>
+
+    <BspEntity>
+      <Name>worlds/bsp/single_player_proto_world_01.bsp</Name>
+    </BspEntity>
+
+    <GenericNPC>
+       <name>guard</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_viper.pcx</md2texture>
+       <abs-coor>275.33, 34, 241.26</abs-coor>
+       <abs-dir>-3.1, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+    <GenericNPC>
+       <name>secondguard</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_freakmagnet.pcx</md2texture>
+       <abs-coor>440, 90, 180</abs-coor>
+       <abs-dir>-3.1, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+
+    <GenericNPC>
+       <name>prisoner</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_albat.pcx</md2texture>
+       <abs-coor>-69,36, 74</abs-coor>
+       <abs-dir>-1.55, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+   <GenericNPC>
+       <name>Secondprisoner</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_fiend.pcx</md2texture>
+       <abs-coor>20, 34,110</abs-coor>
+       <abs-dir>-1.55, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+    <GenericNPC>
+       <name>statist</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_sarge.pcx</md2texture>
+       <abs-coor>-58, 34, 496</abs-coor>
+       <abs-dir>0, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+    <GenericNPC>
+       <name>statist2</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_sarge.pcx</md2texture>
+       <abs-coor>-65, 34, 528</abs-coor>
+       <abs-dir>0, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+    <GenericNPC>
+       <name>floorguy</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_sarge.pcx</md2texture>
+       <abs-coor>800.634338, -10, -340.454163</abs-coor>
+       <abs-dir>0, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+   <GenericNPC>
+       <name>mechanic</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_navy2.pcx</md2texture>
+       <abs-coor>991.192261, 5, -1878.394287</abs-coor>
+       <abs-dir>0, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+
+    <GenericNPC>
+       <name>mechanic2</name>
+       <model>models/creatures/male.md2, 10</model>
+       <md2texture>male_navy2.pcx</md2texture>
+       <abs-coor>1564.473999, 5, -1923.821533</abs-coor>
+       <abs-dir>0, 0, 1, 0</abs-dir>
+    </GenericNPC>
+
+   <TestEntity>
+       <name>fallingguy</name>
+       <model>models/creatures/doom_guy.md2, 10</model>
+       <md2texture>doom_guy.png</md2texture>
+       <abs-coor>620.5, 500, -750</abs-coor>
+       <abs-dir>-1.55, 0, 0, 1</abs-dir>
+    </TestEntity>
+
+    <Door>
+       <name>laboratory door</name>
+       <scale>32.0</scale>
+       <action-radius>40.0</action-radius>
+       <abs-coor>173, 47, 280</abs-coor>
+    </Door>
+
+
+    <RepairStation>
+       <name>repair station 01</name>
+       <scale>80.0</scale>
+       <abs-coor>814.349670, -21.959781, -1695.255981</abs-coor>
+    </RepairStation>
+
+
+    <FPSPlayer>
+      <name>Player</name>
+      <abs-coor>-148,20,87</abs-coor>
+      <model>models/creatures/droidika.md2, 10</model>
+      <md2texture>droidika.png</md2texture>
+    </FPSPlayer>
+
+
+    <Spacecraft2D>
+      <name>SPACE_CRAFT</name>
+      <abs-coor>1600, 0.004610, -1700.0</abs-coor>
+      <enter-radius>100000</enter-radius>
+      <travel-speed>20</travel-speed>
+      <travel-height>5</travel-height>
+      <travel-distance>40, 80</travel-distance>
+    </Spacecraft2D>
+
+    <SpaceShip>
+      <name>spaceship</name>
+      <model>models/ships/fighter.obj,20</model>
+      <abs-coor>624.164124, 0.004610, -1721.440796</abs-coor>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>spaceship1</name>
+      <model>models/ships/reap_#.obj,20</model>
+      <abs-coor>1160.289307, -10.959778, -1874.250732</abs-coor>
+      <abs-dir> -1.5,0,1,0 </abs-dir>
+    </SpaceShip>
+
+    <SpaceShip>
+      <name>spaceship2</name>
+      <model>models/ships/mantawing.obj,20</model>
+      <abs-coor>1373.289307, -10.959778, -1874.250732</abs-coor>
+      <abs-dir> -1.5,0,1,0 </abs-dir>
+    </SpaceShip>
+
+
+    <SpaceShip>
+      <name>spaceship3</name>
+      <model>models/ships/powerdrifter.obj,15</model>
+      <abs-coor>811.904358, -11.959779, -1698.305786</abs-coor>
+    </SpaceShip>
+
+
+
+    <!-- HERE IS THE ARCADE SHOOTER -->
+    <!-- NPC's -->
+    <NPC2> <abs-coor>2500, 0.004610, -1700.0</abs-coor> </NPC2>
+
+
+
+    <!-- BELOW THIS LINE (delete this line later)-->
+
+
+    <!--
+    <TurbineHover>
+      <name>Player</name>
+    </TurbineHover>
+    -->
+
+<!--
+    <TestEntity>
+      <model>models/creatures/gork</model>
+    </TestEntity>
+-->
+  </WorldEntities>
+
+
+    <LightManager>
+    <Lights>
+      <Light>
+       <diffuse-color>1,1,1</diffuse-color>
+       <abs-coor>100,100,50</abs-coor>
+      </Light>
+    </Lights>
+    <ambient-color>1,1,1</ambient-color>
+  </LightManager>
+
+
+</WorldDataFile>
+