Index: orxonox/trunk/src/factory.h
===================================================================
--- orxonox/trunk/src/factory.h	(revision 4113)
+++ orxonox/trunk/src/factory.h	(revision 4114)
@@ -80,7 +80,4 @@
 const char* grabParameter( TiXmlElement* root, const char* name);
 
-
-
-
 #endif /* _FACTORY_H */
 
Index: orxonox/trunk/src/game_loader.cc
===================================================================
--- orxonox/trunk/src/game_loader.cc	(revision 4113)
+++ orxonox/trunk/src/game_loader.cc	(revision 4114)
@@ -290,5 +290,5 @@
 	assert( factory != NULL);
 	
-	PRINTF0("Registered factory for '%s'\n", factory->getFactoryName());
+	PRINTF(4)("Registered factory for '%s'\n", factory->getFactoryName());
 	
 	if( first == NULL) first = factory;
@@ -302,23 +302,25 @@
 BaseObject* GameLoader::fabricate( TiXmlElement* element)
 {
-	assert( element != NULL);
-	
-	if( first == NULL)
-	{
-		PRINTF0("GameLoader does not know any factories, fabricate() failed\n");
-		return NULL;
-	}
-	
-	if( element->Value() != NULL)
-	{
-		PRINTF0("Attempting fabrication of a '%s'\n", element->Value());
-		BaseObject* b = first->fabricate( element);
-		if( b == NULL) PRINTF0("Failed to fabricate a '%s'\n", element->Value());
-		else PRINTF0("Successfully fabricated a '%s'\n", element->Value());
-		return b;
-	}
-	
-	PRINTF0("Fabricate failed, TiXmlElement did not contain a value\n");
-	
-	return NULL;
-}
+  assert( element != NULL);
+	
+  if( first == NULL)
+    {
+      PRINTF(1)("GameLoader does not know any factories, fabricate() failed\n");
+      return NULL;
+    }
+	
+  if( element->Value() != NULL)
+    {
+      PRINTF(4)("Attempting fabrication of a '%s'\n", element->Value());
+      BaseObject* b = first->fabricate( element);
+      if( b == NULL) 
+	PRINTF(2)("Failed to fabricate a '%s'\n", element->Value());
+      else 
+	PRINTF(4)("Successfully fabricated a '%s'\n", element->Value());
+      return b;
+    }
+	
+  PRINTF(2)("Fabricate failed, TiXmlElement did not contain a value\n");
+	
+  return NULL;
+}
Index: orxonox/trunk/src/story_entities/campaign.cc
===================================================================
--- orxonox/trunk/src/story_entities/campaign.cc	(revision 4113)
+++ orxonox/trunk/src/story_entities/campaign.cc	(revision 4114)
@@ -41,5 +41,5 @@
   int id;
   
-  PRINTF0("Loading Campaign...\n");
+  PRINTF(3)("Loading Campaign...\n");
   
   assert( root != NULL);
@@ -53,5 +53,5 @@
   if( string == NULL || sscanf(string, "%d", &id) != 1)
     {
-      PRINTF0("Campaign is missing a proper 'identifier'\n");
+      PRINTF(2)("Campaign is missing a proper 'identifier'\n");
       this->setStoryID( -1);
     }
@@ -62,5 +62,5 @@
   if( element == NULL)
     {
-      PRINTF0("Campaign is missing a proper 'WorldList'\n");
+      PRINTF(2)("Campaign is missing a proper 'WorldList'\n");
     }
   else
Index: orxonox/trunk/src/world_entities/player.cc
===================================================================
--- orxonox/trunk/src/world_entities/player.cc	(revision 4113)
+++ orxonox/trunk/src/world_entities/player.cc	(revision 4114)
@@ -82,37 +82,4 @@
 Player::Player(TiXmlElement* root) : WorldEntity(root)
 {
-  /*
-    char* temp;
-    const char* string;
-    string = grabParameter( root, "name");
-    if( string == NULL)
-    {
-    PRINTF0("Player is missing a proper 'name'\n");
-    string = "Unknown";
-    temp = new char[strlen(string + 2)];
-    strcpy( temp, string);
-    this->setName( temp);
-    }
-    else
-    {
-    temp = new char[strlen(string + 2)];
-    strcpy( temp, string);
-    this->setName( temp);
-    }
-    
-    this->model = NULL;
-    string = grabParameter( root, "model");
-    if( string != NULL)
-    this->model = (Model*)ResourceManager::getInstance()->load(string, OBJ, RP_CAMPAIGN);
-    else
-    {
-    PRINTF0("Player is missing a proper 'model'\n");
-    this->model = (Model*)ResourceManager::getInstance()->load("models/reaplow.obj", OBJ, RP_CAMPAIGN);
-    }
-    if( this->model == NULL)
-    {
-    PRINTF0("Player model '%s' could not be loaded\n", string);
-    }
-  */
   this->weapons = new tList<Weapon>();
   this->activeWeapon = NULL;
Index: orxonox/trunk/src/world_entities/world_entity.cc
===================================================================
--- orxonox/trunk/src/world_entities/world_entity.cc	(revision 4113)
+++ orxonox/trunk/src/world_entities/world_entity.cc	(revision 4114)
@@ -30,11 +30,4 @@
 /**
    \brief standard constructor
-   
-   Every derived contructor HAS to call the previous one supplying the isFree parameter. This is necessary to distunguish
-   between free and bound entities. The difference between them is simply the fact that the movement of a free entity is
-   not bound to the track of a world. Use this to implement projectile or effect classes that do not have to travel along the track.
-   To specify an entity to be free or bound set the default parameter in the declaration of the constructor.
-   Theoretically you should never have to call the constructor of an Entity directly, for it is called by the spawn() function of the World
-   class. So if you want to create a new entity at any time, call World::spawn(). It will handle everything that is necessary.
 */
 WorldEntity::WorldEntity ()
@@ -46,4 +39,7 @@
 }
 
+/**
+   \brief Loads the WordEntity-specific Part of any derived Class
+*/
 WorldEntity::WorldEntity(TiXmlElement* root)
 {
@@ -54,5 +50,5 @@
   if( string == NULL)
     {
-      PRINTF(0)("WorldEntity is missing a proper 'name'\n");
+      PRINTF(2)("WorldEntity is missing a proper 'name'\n");
       string = "Unknown";
       temp = new char[strlen(string + 2)];
@@ -69,16 +65,16 @@
   this->model = NULL;
   string = grabParameter( root, "model");
+  printf("::::::::::::::::::::::string is %s\n", string);
   if( string != NULL)
     this->model = (Model*)ResourceManager::getInstance()->load(string, OBJ, RP_CAMPAIGN);
   else
     {
-      PRINTF(0)("WorldEntity is missing a proper 'model'\n");
+      PRINTF(2)("WorldEntity is missing a proper 'model'\n");
       this->model = NULL;
     }
   if( this->model == NULL)
     {
-      PRINTF(0)("WorldEntity model '%s' could not be loaded\n", string);
-    }
-
+      PRINTF(2)("WorldEntity model '%s' could not be loaded\n", string);
+    }
   this->bDraw = true;
 }