Index: /orxonox/branches/particleEngine/src/defs/globals.h
===================================================================
--- /orxonox/branches/particleEngine/src/defs/globals.h	(revision 4127)
+++ /orxonox/branches/particleEngine/src/defs/globals.h	(revision 4128)
@@ -46,4 +46,5 @@
 #define CONFIG_NAME_TEXTURE_DETAIL "Texture-Detail"
 #define CONFIG_NAME_MODEL_DETAIL "Model-Detail"
+#define CONFIG_NAME_PARTICLES_ENABLED "Particles Enabled"
 #define CONFIG_NAME_ANTI_ALIASING "Anti-Aliasing"
 #define CONFIG_NAME_FILTER_METHOD "Filtering-Method"
Index: /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_emitter.h
===================================================================
--- /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_emitter.h	(revision 4127)
+++ /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_emitter.h	(revision 4128)
@@ -22,6 +22,6 @@
 
  public:
-  ParticleEmitter(const Vector& direction, float angle = .5, float emissionRate = 1.0,
-		  float velocity = 1.0);
+  ParticleEmitter(const Vector& direction, float angle = .5,
+		  float emissionRate = 1.0, float velocity = 1.0);
   virtual ~ParticleEmitter(void);
 
Index: /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_engine.h
===================================================================
--- /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_engine.h	(revision 4127)
+++ /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_engine.h	(revision 4128)
@@ -8,4 +8,6 @@
 
 #include "base_object.h"
+#include "particle_system.h"
+#include "particle_emitter.h"
 
 // FORWARD DEFINITION 
Index: /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_system.h
===================================================================
--- /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_system.h	(revision 4127)
+++ /orxonox/branches/particleEngine/src/lib/graphics/particles/particle_system.h	(revision 4128)
@@ -54,5 +54,6 @@
 
  public:
-  ParticleSystem(unsigned int maxCount = PARTICLE_DEFAULT_MAX_COUNT, PARTICLE_TYPE type = PARTICLE_DEFAULT_TYPE);
+  ParticleSystem(unsigned int maxCount = PARTICLE_DEFAULT_MAX_COUNT,
+		 PARTICLE_TYPE type = PARTICLE_DEFAULT_TYPE);
   virtual ~ParticleSystem();
   void setName(const char* name);
@@ -63,5 +64,6 @@
   void setInheritSpeed(float value);
   void setLifeSpan(float lifeSpan, float randomLifeSpan = 0.0);
-  void setRadius(float startRadius, float endRadius, float randomStartRadius = 0.0, float randomEndRadius = 0.0);
+  void setRadius(float startRadius, float endRadius,
+		 float randomStartRadius = 0.0, float randomEndRadius = 0.0);
   void setConserve(float conserve);
   void setMass(float mass, float randomMass);
Index: /orxonox/branches/particleEngine/src/lib/gui/gui/gui_video.cc
===================================================================
--- /orxonox/branches/particleEngine/src/lib/gui/gui/gui_video.cc	(revision 4127)
+++ /orxonox/branches/particleEngine/src/lib/gui/gui/gui_video.cc	(revision 4128)
@@ -104,4 +104,5 @@
       Label* modelDetailLabel;  //!< Label for model-detail.
       Menu* modelDetail;        //!< model-detail.
+      CheckButton* particles;   //!< If the Particles should be enabled
       Label* antiAliasingLabel; //!< Label for the anti-aliasing mode.
       Menu* antiAliasing;       //!< Menu for the Antialiasing-mode.
@@ -139,4 +140,9 @@
       advancedBox->fill(modelDetail);
       
+      particles = new CheckButton(CONFIG_NAME_PARTICLES_ENABLED);
+      particles->saveability();
+      particles->setDefaultValue(1);
+      advancedBox->fill(particles);
+
       antiAliasingLabel = new Label("Anti-Aliasing-depth:");
       advancedBox->fill(antiAliasingLabel);
@@ -152,4 +158,6 @@
       filterMethod->saveability();
       advancedBox->fill(filterMethod);
+
+
   
       closeButton = new Button("close");
Index: /orxonox/branches/particleEngine/src/story_entities/world.cc
===================================================================
--- /orxonox/branches/particleEngine/src/story_entities/world.cc	(revision 4127)
+++ /orxonox/branches/particleEngine/src/story_entities/world.cc	(revision 4128)
@@ -40,4 +40,5 @@
 #include "garbage_collector.h"
 #include "animation_player.h"
+#include "particle_engine.h"
 
 #include "command_node.h"
@@ -207,4 +208,5 @@
   delete this->lightMan;
   delete this->trackManager;
+  delete this->particleEngine;
   TextEngine::getInstance()->flush();
 
@@ -251,4 +253,5 @@
   this->garbageCollector = GarbageCollector::getInstance();
 
+  this->particleEngine = ParticleEngine::getInstance();
   this->trackManager = TrackManager::getInstance();
   this->lightMan = LightManager::getInstance();
@@ -489,4 +492,12 @@
   this->spawn(terrain);
 
+
+  ParticleSystem* system = new ParticleSystem(1000);
+  system->setLifeSpan(1);
+  system->setRadius(2, 0, 2, 0);
+  ParticleEmitter* emitter = new ParticleEmitter(Vector(-1, 0, 0), 0, 500);
+  emitter->setParent(this->localPlayer);
+  
+  particleEngine->addConnection(emitter, system);
 }
 
@@ -951,4 +962,6 @@
 
   TextEngine::getInstance()->draw();
+  particleEngine->draw();
+
   lightMan->draw(); // must be at the end of the drawing procedure, otherwise Light cannot be handled as PNodes //
 }
@@ -1136,4 +1149,5 @@
 
       AnimationPlayer::getInstance()->tick(seconds);
+      particleEngine->tick(seconds);
     }
   this->lastFrame = currentFrame;
Index: /orxonox/branches/particleEngine/src/story_entities/world.h
===================================================================
--- /orxonox/branches/particleEngine/src/story_entities/world.h	(revision 4127)
+++ /orxonox/branches/particleEngine/src/story_entities/world.h	(revision 4128)
@@ -20,4 +20,5 @@
 class GLMenuImageScreen;
 class LightManager;
+class ParticleEngine;
 class Terrain;
 class GarbageCollector;
@@ -107,4 +108,5 @@
   PNode* nullParent;                  //!< The zero-point, that everything has as its parent.
   TrackManager* trackManager;         //!< The reference of the TrackManager that handles the course through the Level.
+  ParticleEngine* particleEngine;     //!< The ParticleEngine of the World.
   Camera* localCamera;                //!< The current Camera
   WorldEntity* sky;                   //!< The Environmental Heaven of orxonox \todo insert this to environment insted